import pygame
pygame.init()
pygame.mixer.init()
surface = pygame.Surface((396, 224))
SCALE = 1.5
screen = pygame.display.set_mode((396 * SCALE, 224 * SCALE))

DWIDTH = 396
DHEIGHT = 224

def rgb565_to_rgb888(color):
    """Convertit une couleur RGB565 en RGB888"""
    r = (color >> 11) & 0x1F
    g = (color >> 5) & 0x3F
    b = color & 0x1F
    return (r << 3, g << 2, b << 3)

def rgb888_to_rgb565(color):
    """Convertit une couleur RGB888 en RGB565"""
    r = (color[0] >> 3) & 0x1F
    g = (color[1] >> 2) & 0x3F
    b = (color[2] >> 3) & 0x1F
    return (r << 11) | (g << 5) | b

def drect(x1,y1,x2,y2,color):
    """dessine un rectangle de coin superieur gauche (x1,y1)
    de largeur x2 et hauteur y2"""
    color = rgb565_to_rgb888(color)
    pygame.draw.rect(surface, color, (x1,y1,x2-x1+1,y2-y1+1))

def dclear(color):
    """efface l'ecran en le remplissant de la couleur color"""
    color = rgb565_to_rgb888(color)
    surface.fill(color)
    pygame.display.update()

def creaTexteObj(texte, Police, couleur):
    texteSurface = Police.render(texte, False, couleur)
    return texteSurface, texteSurface.get_rect()

def message(texte, taille, col, x, y, police, trans=255):
    font_Texte = pygame.font.Font(police, taille)
    font_TexteSurf, font_TexteRect = creaTexteObj(texte, font_Texte, (col[0], col[1], col[2], 255))
    font_TexteRect.center = x, y
    surface.blit(font_TexteSurf, font_TexteRect)
def message_left(texte, taille, col, x, y, police, trans=255):
    font_Texte = pygame.font.Font(police, taille)
    font_TexteSurf, font_TexteRect = creaTexteObj(texte, font_Texte, (col[0], col[1], col[2], 255))
    font_TexteRect.topleft = x, y
    surface.blit(font_TexteSurf, font_TexteRect)
    return font_TexteSurf, font_TexteRect

def taille_texte_left(texte, taille, couleur, x, y, police):
    font_Texte = pygame.font.Font(police, taille)
    font_TexteSurf, font_TexteRect = creaTexteObj(texte, font_Texte, couleur)
    font_TexteRect.topleft = x, y
    return font_TexteSurf, font_TexteRect

def dtext(x,y,color,texte):
    color = rgb565_to_rgb888(color)
    message_left(texte,int(16/1.5),color,x,y,"uf5x7.ttf",255)

DTEXT_LEFT   = 0,
DTEXT_CENTER = 1,
DTEXT_RIGHT  = 2,

DTEXT_TOP    = 0,
DTEXT_MIDDLE = 1,
DTEXT_BOTTOM = 2,
def dtext_opt(x, y, fg, bg, halign, valign, str, size):
    fg = rgb565_to_rgb888(fg)
    bg = rgb565_to_rgb888(bg)
    font_Texte = pygame.font.Font("uf5x7.ttf", int(size/1.5))
    font_TexteSurf, font_TexteRect = creaTexteObj(str, font_Texte, (fg[0], fg[1], fg[2], 255))
    if halign == DTEXT_LEFT:
        font_TexteRect.topleft = x, y
    elif halign == DTEXT_CENTER:
        font_TexteRect.center = x, y
    elif halign == DTEXT_RIGHT:
        font_TexteRect.topright = x, y
    if valign == DTEXT_TOP:
        font_TexteRect.topleft = x, y
    elif valign == DTEXT_MIDDLE:
        font_TexteRect.center = x, y
    elif valign == DTEXT_BOTTOM:
        font_TexteRect.bottomleft = x, y
    # Draw the background rectangle
    pygame.draw.rect(surface, bg, font_TexteRect)
    surface.blit(font_TexteSurf, font_TexteRect)


def dpixel(x,y,color):
    """dessine un pixel de coordonnees (x,y)"""
    color = rgb565_to_rgb888(color)
    surface.set_at((x, y), color)

def dline(x1,y1,x2,y2,color):
    """dessine une ligne de coordonnees (x1,y1) a (x2,y2)"""
    color = rgb565_to_rgb888(color)
    pygame.draw.line(surface, color, (x1,y1), (x2,y2), 1)

def dupdate():
    """Rafraîchit l'affichage avec redimensionnement"""
    scaled_surface = pygame.transform.scale(surface, screen.get_size())
    screen.blit(scaled_surface, (0, 0))
    pygame.display.update()
    # Limiter le framerate
    pygame.time.delay(15)

#class KeyType(Enum):
KEYEV_NONE = 0
KEYEV_DOWN = 1
KEYEV_UP = 2
KEYEV_HOLD = 3


#class KEYS(Enum):
KEY_NONE=pygame.K_UNKNOWN
KEY_F1=pygame.K_F1
KEY_F2=pygame.K_F2
KEY_F3=pygame.K_F3
KEY_F4=pygame.K_F4
KEY_F5=pygame.K_F5
KEY_F6=pygame.K_F6
KEY_SHIFT=pygame.K_LSHIFT
KEY_OPTN=pygame.K_LALT
KEY_VARS=8
KEY_MENU=pygame.K_ESCAPE
KEY_LEFT=pygame.K_LEFT
KEY_UP=pygame.K_UP
KEY_ALPHA=pygame.K_SPACE
KEY_SQUARE=13
KEY_POWER=14
KEY_EXIT=15
KEY_DOWN=pygame.K_DOWN
KEY_RIGHT=pygame.K_RIGHT
KEY_XOT=18
KEY_LOG=19
KEY_LN=20
KEY_SIN=21
KEY_COS=22
KEY_TAN=23
KEY_FRAC=24
KEY_FD=25
KEY_LEFTP=26
KEY_RIGHTP=27
KEY_COMMA=28
KEY_ARROW=29
KEY_7=pygame.K_7
KEY_8=pygame.K_8
KEY_9=pygame.K_9
KEY_DEL=33
KEY_ACON=34
KEY_4=pygame.K_4
KEY_5=pygame.K_5
KEY_6=pygame.K_6
KEY_MUL=38
KEY_DIV=39
KEY_1=pygame.K_1
KEY_2=pygame.K_2
KEY_3=pygame.K_3
KEY_ADD=43
KEY_SUB=44
KEY_0=pygame.K_0
KEY_DOT=46
KEY_EXP=47
KEY_NEG=48
KEY_EXE=pygame.K_RETURN
KEY_MOUSE=pygame.K_UNKNOWN

class key_event:
    def __init__(self):
        self.time = 0
        self.mod  = False
        self.shift= False
        self.alpha= False
        self.type = KEYEV_NONE
        self.key  = KEY_NONE

events = []
holdkeys=[]

MOUSE_POS = [0, 0]

def cleareventflips():
    pass

def clearevents():
    global events, holdkeys, MOUSE_POS
    events.clear()
    for key in holdkeys:
        ke = key_event()
        ke.time = 0
        ke.type = KEYEV_HOLD
        ke.key = key
        events.append(ke)
    x,y = pygame.mouse.get_pos()
    #check if x and y are in the screen size
    if x >= 0 and x < pygame.display.get_window_size()[0] and y >= 0 and y < pygame.display.get_window_size()[1]:
        MOUSE_POS[0] = int(x/SCALE)
        MOUSE_POS[1] = int(y/SCALE)
    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            raise SystemExit
        if event.type == pygame.KEYDOWN:
            ke = key_event()
            ke.time = 0
            ke.type = KEYEV_DOWN
            ke.key = int(event.key)
            events.append(ke)
            holdkeys.append(ke.key)
        if event.type == pygame.KEYUP:
            ke = key_event()
            ke.time = 0
            ke.type = KEYEV_UP
            ke.key = int(event.key)
            events.append(ke)
            if ke.key in holdkeys:
                holdkeys.remove(ke.key)
        if event.type == pygame.MOUSEBUTTONDOWN:
            ke = key_event()
            ke.time = 0
            ke.type = KEYEV_DOWN
            ke.key = int(KEY_MOUSE)
            events.append(ke)
            if KEY_MOUSE not in holdkeys:
                holdkeys.append(KEY_MOUSE)
        if event.type == pygame.MOUSEBUTTONUP:
            ke = key_event()
            ke.time = 0
            ke.type = KEYEV_UP
            ke.key = int(KEY_MOUSE)
            events.append(ke)
            if KEY_MOUSE in holdkeys:
                holdkeys.remove(KEY_MOUSE)
    ke = key_event()
    ke.time = 0
    ke.type = KEYEV_NONE
    ke.key = KEY_NONE
    events.append(ke)


def pollevent():
    global events, holdkeys
    if len(events) > 0:
        return events.pop(0)
    clearevents()
    return events.pop(0)

def keydown(key):
    """retourne vrai si la touche key est appuyee"""
    for event in events:
        if event.type == KEYEV_HOLD and event.key == key:
            return True
    return False
def keyreleased(key):
    """retourne vrai si la touche key est relachee"""
    for event in events:
        if event.type == KEYEV_UP and event.key == key:
            return True
    return False
def keypressed(key):
    """retourne vrai si la touche key est maintenue"""
    for event in events:
        if event.type == KEYEV_DOWN and event.key == key:
            return True
    return False

C_WHITE = rgb888_to_rgb565((255, 255, 255))
C_BLACK = rgb888_to_rgb565((0, 0, 0))
C_NONE = rgb888_to_rgb565((0, 0, 0))

# Graph 90+E uniquement :
C_RED = rgb888_to_rgb565((255, 0, 0))
C_GREEN = rgb888_to_rgb565((0, 255, 0))
C_BLUE = rgb888_to_rgb565((0, 0, 255))
def C_RGB(r,g,b):
    r = int(r*100/31)
    g = int(g*100/31)
    b = int(b*100/31)
    return rgb888_to_rgb565((r,g,b))


IMAGE_RGB565     = 0#	65536	Non	rgb565
IMAGE_RGB565A    = 1#	65535 + transparent	Non	rgb565a
IMAGE_P8_RGB565  = 4#	256	Oui (1-256)	p8_rgb565
IMAGE_P8_RGB565A = 5#	255 + transparent	Oui (1-256)	p8_rgb565a
IMAGE_P4_RGB565  = 6#	16	Oui (16)	p4_rgb565
IMAGE_P4_RGB565A = 3#	15 + transparent	Oui (16)	p4_rgb565a

def image_alpha(format):
    if format == IMAGE_RGB565A:
        return 0x0001
    elif format == IMAGE_P8_RGB565A:
        return 128
    elif format == IMAGE_P4_RGB565A:
        return 0
    else:
        # A value that cannot be found in any pixel of any format
        return 0x10000

class image:
    def __init__(self,format, color_count, width, height, stride, data, palette):
        self.format = format
        self.width = width
        self.height = height
        self.stride = stride
        self.color_count = color_count
        self.data = data
        self.data_hash = hash(data)
        self.palette = palette
        self.surface = None
        self.generate()

    def on_draw(self):
        if hash(self.data) != self.data_hash:
            raise ValueError("Image data has changed since it was created")

    def generate(self):
        #change palette = b'\x00\x00\xf8\x00\xff\xff' and data = b'\x80\x81\x80\x81\x82\x81\x80\x81\x80' to arrays
        if self.palette is not None:
            palette = [int.from_bytes(self.palette[i:i+2], 'big') for i in range(0, len(self.palette), 2)]
        if self.format == IMAGE_RGB565 or self.format == IMAGE_RGB565A:
            data = [int.from_bytes(self.data[i:i+2], 'big') for i in range(0, len(self.data), 2)]
        else:
            data = [int.from_bytes(self.data[i:i+1], 'big') for i in range(0, len(self.data), 1)]
        #convert image to pygame surface
        if  self.format == IMAGE_RGB565:
            self.surface = pygame.Surface((self.width, self.height))
            for y in range(self.height):
                for x in range(self.width):
                    color = data[y*self.width + x]
                    r, g, b = rgb565_to_rgb888(color)
                    self.surface.set_at((x, y), (r, g, b))
        elif self.format == IMAGE_RGB565A:
            self.surface = pygame.Surface((self.width, self.height), pygame.SRCALPHA)
            for y in range(self.height):
                for x in range(self.width):
                    color = data[y*self.width + x]
                    if color == image_alpha(self.format):
                        self.surface.set_at((x, y), (0, 0, 0, 255))
                    else:
                        r, g, b = rgb565_to_rgb888(color)
                        self.surface.set_at((x, y), (r, g, b, 255))
        elif self.format == IMAGE_P8_RGB565:
            self.surface = pygame.Surface((self.width, self.height))
            for y in range(self.height):
                for x in range(self.width):
                    index = data[y * self.stride + x]
                    color = palette[index - 128]
                    r, g, b = rgb565_to_rgb888(color)
                    self.surface.set_at((x, y), (r, g, b))
        elif self.format == IMAGE_P8_RGB565A:
            self.surface = pygame.Surface((self.width, self.height), pygame.SRCALPHA)
            for y in range(self.height):
                for x in range(self.width):
                    index = data[y * self.stride + x]
                    if index == image_alpha(self.format):
                        self.surface.set_at((x, y), (0, 0, 0, 0))
                    else:
                        color = palette[index - 128]
                        r, g, b = rgb565_to_rgb888(color)
                        self.surface.set_at((x, y), (r, g, b, 255))
        elif self.format == IMAGE_P4_RGB565:
            self.surface = pygame.Surface((self.width, self.height))
            for y in range(self.height):
                for x in range(self.width):
                    index = data[(y * self.stride + (x//2))]
                    index = index & 0x0F if x & 1 else index >> 4
                    color = palette[index]
                    r, g, b = rgb565_to_rgb888(color)
                    self.surface.set_at((x, y), (r, g, b))
        elif self.format == IMAGE_P4_RGB565A:
            self.surface = pygame.Surface((self.width, self.height), pygame.SRCALPHA)
            for y in range(self.height):
                for x in range(self.width):
                    index = data[(y * self.stride + (x//2))]
                    index = index & 0x0F if x & 1 else index >> 4
                    if index == image_alpha(self.format):
                        self.surface.set_at((x, y), (0, 0, 0, 0))
                    else:
                        color = palette[index]
                        r, g, b = rgb565_to_rgb888(color)
                        self.surface.set_at((x, y), (r, g, b, 255))

def image_p8_rgb565a(width, height, data, palette):
    return image(IMAGE_P8_RGB565A, 256, width, height, width, data, palette)
def image_rgb565a(width, height, data):
    return image(IMAGE_RGB565A, 65536, width, height, width, data, b'')
def image_rgb565(width, height, data):
    return image(IMAGE_RGB565, 65536, width, height, width, data, b'')
def dimage(x, y, img):
    """dessine une image de coin superieur gauche (x;y)"""
    img.on_draw()
    surface.blit(img.surface, (x, y))

def dsubimage(x, y, image, left, top, width, height):
    """dessine une image de coin superieur gauche (x;y)"""
    image.on_draw()
    subimage = pygame.Surface((width, height), pygame.SRCALPHA)
    subimage.blit(image.surface, (0, 0), (left, top, width, height))
    surface.blit(subimage, (x, y))
        
def getkey():
    """retourne la touche appuyee"""
    while 1:
        e = pollevent()
        if e.type != KEYEV_NONE:
            return e.key
        dupdate()


"""
import struct
data = []
for y in range(16):
    for x in range(16):
        data.append(rgb888_to_rgb565(((x*100)//16, (y*100)//16, 0)))

data = bytearray(struct.pack(">" + "H" * len(data), *data))
print(data)
"""